Re: [ANNOUNCE] Git v2.34.0-rc2

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

 



On Wed, Nov 10, 2021 at 12:41:11AM -0500, Jeff King wrote:

> So it may not be a bug we need to fix in Git. But shipping v2.34 with
> lots of test failures may cause some headaches. Maybe we need to tighten
> up the GPGSSH prereq checks to block broken versions?

This is what I came up with, but I'm not sure it there's a better way to
find the broken version. I don't think there's a way to get a version
number out of ssh-keygen (and anyway, checking the behavior of the
command is a more robust test). My fears are:

  - this does cause several segfaults per test run on affected
    platforms, which will pollute the kernel log, etc.

  - we're not really testing the desired behavior, just looking for a
    known-problem. The segfault may get fixed but we'd still have other
    bugs.

So it would be nice to have a more exact test, but without understanding
the openssh bug, I think this is the best we can do in the meantime.

-- >8 --
Subject: [PATCH] t/lib-gpg: avoid broken versions of ssh-keygen

The "-Y find-principals" option of ssh-keygen seems to be broken in
Debian's openssh-client 1:8.7p1-1, whereas it works fine in 1:8.4p1-5.
This causes several failures for GPGSSH tests. We fulfill the
prerequisite because generating the keys works fine, but actually
verifying a signature causes results ranging from bogus results to
ssh-keygen segfaulting.

We can find the broken version during the prereq check by feeding it
empty input. This should result in it complaining to stderr, but in the
broken version it triggers the segfault, causing the GPGSSH tests to be
skipped.

Signed-off-by: Jeff King <peff@xxxxxxxx>
---
 t/lib-gpg.sh | 6 ++++++
 1 file changed, 6 insertions(+)

diff --git a/t/lib-gpg.sh b/t/lib-gpg.sh
index 1d8e5b5b7e..a3f285f515 100644
--- a/t/lib-gpg.sh
+++ b/t/lib-gpg.sh
@@ -104,6 +104,12 @@ test_lazy_prereq GPGSSH '
 	test $? != 127 || exit 1
 	echo $ssh_version | grep -q "find-principals:missing signature file"
 	test $? = 0 || exit 1;
+
+	# some broken versions of ssh-keygen segfault on find-principals;
+	# avoid testing with them.
+	ssh-keygen -Y find-principals -f /dev/null -s /dev/null
+	test $? = 139 && exit 1
+
 	mkdir -p "${GNUPGHOME}" &&
 	chmod 0700 "${GNUPGHOME}" &&
 	(setfacl -k "${GNUPGHOME}" 2>/dev/null || true) &&
-- 
2.34.0.rc1.634.g85d556ea55




[Index of Archives]     [Linux Kernel Development]     [Gcc Help]     [IETF Annouce]     [DCCP]     [Netdev]     [Networking]     [Security]     [V4L]     [Bugtraq]     [Yosemite]     [MIPS Linux]     [ARM Linux]     [Linux Security]     [Linux RAID]     [Linux SCSI]     [Fedora Users]

  Powered by Linux